// Autogenerated from Pigeon (v3.2.1), do not edit directly.
// See also: https://pub.dev/packages/pigeon
#import <Foundation/Foundation.h>
@protocol FlutterBinaryMessenger;
@protocol FlutterMessageCodec;
@class FlutterError;
@class FlutterStandardTypedData;

NS_ASSUME_NONNULL_BEGIN

typedef NS_ENUM(NSUInteger, MapType) {
  MapTypeNormal = 0,
  MapTypeSatellite = 1,
  MapTypeDark = 2,
};

typedef NS_ENUM(NSUInteger, MyLocationType) {
  MyLocationTypeFollowNoCenter = 0,
  MyLocationTypeLocationRotate = 1,
  MyLocationTypeLocationRotateNoCenter = 2,
  MyLocationTypeMapRotateNoCenter = 3,
};

@class MyLocationStyle;
@class LatLng;
@class Location;
@class MapPoi;
@class CameraPosition;
@class MarkerOptions;
@class PolylineOptions;
@class Bitmap;

@interface MyLocationStyle : NSObject
+ (instancetype)makeWithMyLocationType:(MyLocationType)myLocationType;
@property(nonatomic, assign) MyLocationType myLocationType;
@end

@interface LatLng : NSObject
+ (instancetype)makeWithLatitude:(nullable NSNumber *)latitude
    longitude:(nullable NSNumber *)longitude;
@property(nonatomic, strong, nullable) NSNumber * latitude;
@property(nonatomic, strong, nullable) NSNumber * longitude;
@end

@interface Location : NSObject
+ (instancetype)makeWithLatitude:(nullable NSNumber *)latitude
    longitude:(nullable NSNumber *)longitude
    bearing:(nullable NSNumber *)bearing
    accuracy:(nullable NSNumber *)accuracy;
@property(nonatomic, strong, nullable) NSNumber * latitude;
@property(nonatomic, strong, nullable) NSNumber * longitude;
@property(nonatomic, strong, nullable) NSNumber * bearing;
@property(nonatomic, strong, nullable) NSNumber * accuracy;
@end

@interface MapPoi : NSObject
/// `init` unavailable to enforce nonnull fields, see the `make` class method.
- (instancetype)init NS_UNAVAILABLE;
+ (instancetype)makeWithName:(NSString *)name
    position:(LatLng *)position;
@property(nonatomic, copy) NSString * name;
@property(nonatomic, strong) LatLng * position;
@end

@interface CameraPosition : NSObject
+ (instancetype)makeWithBearing:(nullable NSNumber *)bearing
    target:(nullable LatLng *)target
    tilt:(nullable NSNumber *)tilt
    zoom:(nullable NSNumber *)zoom;
@property(nonatomic, strong, nullable) NSNumber * bearing;
@property(nonatomic, strong, nullable) LatLng * target;
@property(nonatomic, strong, nullable) NSNumber * tilt;
@property(nonatomic, strong, nullable) NSNumber * zoom;
@end

@interface MarkerOptions : NSObject
/// `init` unavailable to enforce nonnull fields, see the `make` class method.
- (instancetype)init NS_UNAVAILABLE;
+ (instancetype)makeWithPosition:(LatLng *)position
    alpha:(nullable NSNumber *)alpha
    rotation:(nullable NSNumber *)rotation
    zIndex:(nullable NSNumber *)zIndex
    flat:(nullable NSNumber *)flat
    draggable:(nullable NSNumber *)draggable
    icon:(nullable Bitmap *)icon
    anchor:(nullable NSArray<NSNumber *> *)anchor;
@property(nonatomic, strong) LatLng * position;
@property(nonatomic, strong, nullable) NSNumber * alpha;
@property(nonatomic, strong, nullable) NSNumber * rotation;
@property(nonatomic, strong, nullable) NSNumber * zIndex;
@property(nonatomic, strong, nullable) NSNumber * flat;
@property(nonatomic, strong, nullable) NSNumber * draggable;
@property(nonatomic, strong, nullable) Bitmap * icon;
@property(nonatomic, strong, nullable) NSArray<NSNumber *> * anchor;
@end

@interface PolylineOptions : NSObject
+ (instancetype)makeWithPoints:(nullable NSArray<LatLng *> *)points;
@property(nonatomic, strong, nullable) NSArray<LatLng *> * points;
@end

@interface Bitmap : NSObject
+ (instancetype)makeWithAsset:(nullable NSString *)asset
    bytes:(nullable FlutterStandardTypedData *)bytes;
@property(nonatomic, copy, nullable) NSString * asset;
@property(nonatomic, strong, nullable) FlutterStandardTypedData * bytes;
@end

/// The codec used by TencentMapSdkApi.
NSObject<FlutterMessageCodec> *TencentMapSdkApiGetCodec(void);

@protocol TencentMapSdkApi
- (void)initSdkIosApiKey:(nullable NSString *)iosApiKey agreePrivacy:(NSNumber *)agreePrivacy error:(FlutterError *_Nullable *_Nonnull)error;
@end

extern void TencentMapSdkApiSetup(id<FlutterBinaryMessenger> binaryMessenger, NSObject<TencentMapSdkApi> *_Nullable api);

/// The codec used by TencentMapApi.
NSObject<FlutterMessageCodec> *TencentMapApiGetCodec(void);

@protocol TencentMapApi
- (void)setMapTypeType:(MapType)type error:(FlutterError *_Nullable *_Nonnull)error;
- (void)setCompassEnabledEnabled:(NSNumber *)enabled error:(FlutterError *_Nullable *_Nonnull)error;
- (void)setScaleControlsEnabledEnabled:(NSNumber *)enabled error:(FlutterError *_Nullable *_Nonnull)error;
- (void)setRotateGesturesEnabledEnabled:(NSNumber *)enabled error:(FlutterError *_Nullable *_Nonnull)error;
- (void)setScrollGesturesEnabledEnabled:(NSNumber *)enabled error:(FlutterError *_Nullable *_Nonnull)error;
- (void)setZoomGesturesEnabledEnabled:(NSNumber *)enabled error:(FlutterError *_Nullable *_Nonnull)error;
- (void)setTiltGesturesEnabledEnabled:(NSNumber *)enabled error:(FlutterError *_Nullable *_Nonnull)error;
- (void)setIndoorViewEnabledEnabled:(NSNumber *)enabled error:(FlutterError *_Nullable *_Nonnull)error;
- (void)setTrafficEnabledEnabled:(NSNumber *)enabled error:(FlutterError *_Nullable *_Nonnull)error;
- (void)setBuildingsEnabledEnabled:(NSNumber *)enabled error:(FlutterError *_Nullable *_Nonnull)error;
- (void)setMyLocationButtonEnabledEnabled:(NSNumber *)enabled error:(FlutterError *_Nullable *_Nonnull)error;
- (void)setMyLocationEnabledEnabled:(NSNumber *)enabled error:(FlutterError *_Nullable *_Nonnull)error;
- (void)setMyLocationLocation:(Location *)location error:(FlutterError *_Nullable *_Nonnull)error;
- (void)setMyLocationStyleStyle:(MyLocationStyle *)style error:(FlutterError *_Nullable *_Nonnull)error;
- (void)moveCameraPosition:(CameraPosition *)position duration:(NSNumber *)duration error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSString *)addMarkerOptions:(MarkerOptions *)options error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSString *)addPolylineOptions:(PolylineOptions *)options error:(FlutterError *_Nullable *_Nonnull)error;
- (void)pauseWithError:(FlutterError *_Nullable *_Nonnull)error;
- (void)resumeWithError:(FlutterError *_Nullable *_Nonnull)error;
- (void)destoryWithError:(FlutterError *_Nullable *_Nonnull)error;
@end

extern void TencentMapApiSetup(id<FlutterBinaryMessenger> binaryMessenger, NSObject<TencentMapApi> *_Nullable api);

/// The codec used by TencentMapHandler.
NSObject<FlutterMessageCodec> *TencentMapHandlerGetCodec(void);

@interface TencentMapHandler : NSObject
- (instancetype)initWithBinaryMessenger:(id<FlutterBinaryMessenger>)binaryMessenger;
- (void)onTapLatLng:(LatLng *)latLng completion:(void(^)(NSError *_Nullable))completion;
- (void)onTapPoiPoi:(MapPoi *)poi completion:(void(^)(NSError *_Nullable))completion;
- (void)onLongPressLatLng:(LatLng *)latLng completion:(void(^)(NSError *_Nullable))completion;
- (void)onCameraMoveCameraPosition:(CameraPosition *)cameraPosition completion:(void(^)(NSError *_Nullable))completion;
- (void)onCameraIdleCameraPosition:(CameraPosition *)cameraPosition completion:(void(^)(NSError *_Nullable))completion;
- (void)onTapMarkerMarkerId:(NSString *)markerId completion:(void(^)(NSError *_Nullable))completion;
- (void)onMarkerDragStartMarkerId:(NSString *)markerId latLng:(LatLng *)latLng completion:(void(^)(NSError *_Nullable))completion;
- (void)onMarkerDragMarkerId:(NSString *)markerId latLng:(LatLng *)latLng completion:(void(^)(NSError *_Nullable))completion;
- (void)onMarkerDragEndMarkerId:(NSString *)markerId latLng:(LatLng *)latLng completion:(void(^)(NSError *_Nullable))completion;
@end
/// The codec used by MarkerApi.
NSObject<FlutterMessageCodec> *MarkerApiGetCodec(void);

@protocol MarkerApi
- (void)removeId:(NSString *)id error:(FlutterError *_Nullable *_Nonnull)error;
- (void)setRotationId:(NSString *)id rotation:(NSNumber *)rotation error:(FlutterError *_Nullable *_Nonnull)error;
- (void)setPositionId:(NSString *)id position:(LatLng *)position error:(FlutterError *_Nullable *_Nonnull)error;
- (void)setAnchorId:(NSString *)id x:(NSNumber *)x y:(NSNumber *)y error:(FlutterError *_Nullable *_Nonnull)error;
- (void)setZIndexId:(NSString *)id zIndex:(NSNumber *)zIndex error:(FlutterError *_Nullable *_Nonnull)error;
- (void)setAlphaId:(NSString *)id alpha:(NSNumber *)alpha error:(FlutterError *_Nullable *_Nonnull)error;
- (void)setIconId:(NSString *)id icon:(Bitmap *)icon error:(FlutterError *_Nullable *_Nonnull)error;
- (void)setDraggableId:(NSString *)id draggable:(NSNumber *)draggable error:(FlutterError *_Nullable *_Nonnull)error;
@end

extern void MarkerApiSetup(id<FlutterBinaryMessenger> binaryMessenger, NSObject<MarkerApi> *_Nullable api);

NS_ASSUME_NONNULL_END
